﻿using JetBrains.Annotations;
using UniRx;

namespace Magify
{
    public enum NetworkState
    {
        Reachable,
        NotReachable
    }

    public interface INetworkStatusProvider
    {
        [NotNull]
        public IReactiveProperty<NetworkState> Reachability { get; }
        public bool IsNetworkReachable => Reachability.Value == NetworkState.Reachable;
    }
}